/***********************************************************************************************************************
* DISCLAIMER
* This software is supplied by Renesas Electronics Corporation and is only intended for use with Renesas products.
* No other uses are authorized. This software is owned by Renesas Electronics Corporation and is protected under all
* applicable laws, including copyright laws. 
* THIS SOFTWARE IS PROVIDED "AS IS" AND RENESAS MAKES NO WARRANTIES REGARDING THIS SOFTWARE, WHETHER EXPRESS, IMPLIED
* OR STATUTORY, INCLUDING BUT NOT LIMITED TO WARRANTIES OF MERCHANTABILITY, FITNESS FOR A PARTICULAR PURPOSE AND
* NON-INFRINGEMENT.  ALL SUCH WARRANTIES ARE EXPRESSLY DISCLAIMED.TO THE MAXIMUM EXTENT PERMITTED NOT PROHIBITED BY
* LAW, NEITHER RENESAS ELECTRONICS CORPORATION NOR ANY OF ITS AFFILIATED COMPANIES SHALL BE LIABLE FOR ANY DIRECT,
* INDIRECT, SPECIAL, INCIDENTAL OR CONSEQUENTIAL DAMAGES FOR ANY REASON RELATED TO THIS SOFTWARE, EVEN IF RENESAS OR
* ITS AFFILIATES HAVE BEEN ADVISED OF THE POSSIBILITY OF SUCH DAMAGES.
* Renesas reserves the right, without notice, to make changes to this software and to discontinue the availability 
* of this software. By using this software, you agree to the additional terms and conditions found by accessing the 
* following link:
* http://www.renesas.com/disclaimer
*
* Copyright (C) 2019 Renesas Electronics Corporation. All rights reserved.
***********************************************************************************************************************/

/***********************************************************************************************************************
* File Name    : Config_TPU1_user.c
* Version      : 1.9.0
* Device(s)    : R5F5651EDxFP
* Description  : This file implements device driver for Config_TPU1.
* Creation Date: 2021-03-05
***********************************************************************************************************************/

/***********************************************************************************************************************
Pragma directive
***********************************************************************************************************************/
/* Start user code for pragma. Do not edit comment generated here */
/* End user code. Do not edit comment generated here */

/***********************************************************************************************************************
Includes
***********************************************************************************************************************/
#include "r_cg_macrodriver.h"
#include "Config_TPU1.h"
/* Start user code for include. Do not edit comment generated here */
#include "Config_RSPI0.h"
/* End user code. Do not edit comment generated here */
#include "r_cg_userdefine.h"

/***********************************************************************************************************************
Global variables and functions
***********************************************************************************************************************/
/* Start user code for global. Do not edit comment generated here */

short g_next_send_data;

typedef struct{
  float ch0;
} PCM_float;

extern PCM_float pcm1[];

extern unsigned char g_rspi0_flag;
extern short g_rspi0_send_data;
extern int output_index;
/* End user code. Do not edit comment generated here */

/***********************************************************************************************************************
* Function Name: R_Config_TPU1_Create_UserInit
* Description  : This function adds user code after initializing the TPU1 channel
* Arguments    : None
* Return Value : None
***********************************************************************************************************************/

void R_Config_TPU1_Create_UserInit(void)
{
    /* Start user code for user init. Do not edit comment generated here */
	g_next_send_data = 0;
    /* End user code. Do not edit comment generated here */
}

/***********************************************************************************************************************
* Function Name: r_Config_TPU1_tgi1a_interrupt
* Description  : This function is TGI1A interrupt service routine
* Arguments    : None
* Return Value : None
***********************************************************************************************************************/

#if FAST_INTERRUPT_VECTOR == VECT_PERIB_INTB144
#pragma interrupt r_Config_TPU1_tgi1a_interrupt(vect=VECT(PERIB,INTB144),fint)
#else
#pragma interrupt r_Config_TPU1_tgi1a_interrupt(vect=VECT(PERIB,INTB144))
#endif
static void r_Config_TPU1_tgi1a_interrupt(void)
{
    /* Start user code for r_Config_TPU1_tgi1a_interrupt. Do not edit comment generated here */
	
	float dataf;
	
	//ch0 send & receive
	g_rspi0_send_data = g_next_send_data;

	g_rspi0_flag = 0x1;
	
	setpsw_i();	//multiple interrupt enable
	
	//RSPI-ch0 receive&send
	RSPI0.SPCR.BYTE |= 0xf0;
	
	//next data set
	dataf = (pcm1[output_index].ch0 + 1.0f) / 2.0f * 65536.0f;
  	if (dataf > 65535.0f)
  	{
    	dataf = 65535.0f;
  	}
  	else if (dataf < 0.0f)
  	{
    	dataf = 0.0f;
  	}
		  
	g_next_send_data = (short)((int)(dataf + 0.5f) - 32768);

    /* End user code. Do not edit comment generated here */
}

/***********************************************************************************************************************
* Function Name: r_Config_TPU1_tgi1b_interrupt
* Description  : This function is TGI1B interrupt service routine
* Arguments    : None
* Return Value : None
***********************************************************************************************************************/

#if FAST_INTERRUPT_VECTOR == VECT_PERIB_INTB135
#pragma interrupt r_Config_TPU1_tgi1b_interrupt(vect=VECT(PERIB,INTB135),fint)
#else
#pragma interrupt r_Config_TPU1_tgi1b_interrupt(vect=VECT(PERIB,INTB135))
#endif
static void r_Config_TPU1_tgi1b_interrupt(void)
{
    /* Start user code for r_Config_TPU1_tgi1b_interrupt. Do not edit comment generated here */
	
	//ch1 send & receive
	g_rspi0_send_data = 0;

	g_rspi0_flag = 0x1;
	
	setpsw_i();	//multiple interrupt enable
	
	//RSPI-ch0 receive&send
	RSPI0.SPCR.BYTE |= 0xf0;
	
	//index increment
	output_index++;
	if(output_index >= 49152) output_index = 0;

    /* End user code. Do not edit comment generated here */
}

/* Start user code for adding. Do not edit comment generated here */
/* End user code. Do not edit comment generated here */
